----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity Binary_reg is
    Port ( Clk : 		 in  STD_LOGIC;
           Bin : 		 in  STD_LOGIC_VECTOR (12 downto 0);
			  Strobe_in: in  STD_LOGIC;
			  Modout:   out  STD_LOGIC;
           Ready :   out  STD_LOGIC);
end Binary_reg;

architecture Behavioral of Binary_reg is
	signal Counter: integer range 0 to 15;
	signal Binreg:  STD_LOGIC_VECTOR (12 downto 0);
begin

	Modout <= Binreg(12);
	-----------------------------------------------------------
	-- This process controls the Binreg and hence it loads the
	-- Binreg with the next binary value and shift the same
	-- value leftmost in order to convert
	-----------------------------------------------------------
	Binary_Register: process( Clk)
	begin
		if Rising_edge( Clk) then
			if Strobe_in='1' then
			   Counter <= 0;
				Ready   <= '0';
				Binreg  <= Bin;
			else
			   Counter <= Counter+1;
				if Counter < 12 then
				   Binreg  <= Binreg(11 downto 0)&'0';
				else
				   Ready <= '1';
				end if;
			end if;
		end if;
	end process;
	
end Behavioral;

