----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    09:34:36 08/08/2009 
-- Design Name: 
-- Module Name:    Btn_Detect - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity Btn_Detect is
    Port ( Clk,Scale :                   in  STD_LOGIC;
           Btn3,  Btn2,  Btn1,  Btn0 :   in  STD_LOGIC;
           Pulse3,Pulse2,Pulse1,Pulse0 : out STD_LOGIC );
end Btn_Detect;

architecture Behavioral of Btn_Detect is
   signal Counter: integer range 0 to 50001 := 0;
	signal Clk_Scale: std_logic;
	
	COMPONENT Pulse_Button
	PORT(
		Clk : 		 IN std_logic;
		Scaled_Clk : IN std_logic;
		Button : 	 IN std_logic;          
		Pulse : 		OUT std_logic);
	END COMPONENT;
	
begin
	Button0: Pulse_Button PORT MAP( Clk, Clk_Scale,	Btn0, Pulse0);
	Button1: Pulse_Button PORT MAP( Clk, Clk_Scale,	Btn1, Pulse1);
	Button2: Pulse_Button PORT MAP( Clk, Clk_Scale,	Btn2, Pulse2);
	Button3: Pulse_Button PORT MAP( Clk, Clk_Scale,	Btn3, Pulse3);
	
	Clock_scale: process( Clk)
	begin
	   if Rising_edge( Clk) then
		   Clk_Scale <= '0';
		   if Scale = '0' then
			   Clk_scale <= '1';
			else
			   if Counter >= 49999 then
				   Clk_scale <= '1';
					Counter   <= 0;
				else
				   Counter  <= Counter+1;
				end if;
			end if;
		end if;
	end process;
end Behavioral;

