----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    13:15:07 08/10/2009 
-- Design Name: 
-- Module Name:    Debounced_Button - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity Debounced_Button is
    Generic( Max: Natural := 7);
    Port ( Clk,Scaled_Clk : in  STD_LOGIC;
           Button : in  STD_LOGIC;
           Pulse : out  STD_LOGIC);
end Debounced_Button;

architecture Behavioral of Debounced_Button is
   signal Button_State: Std_logic_vector( Max downto 0) := (others =>'0');
begin
   process( Clk)
	   Variable Toggle_Bit: std_logic := '0';
	begin
		if Rising_edge( Clk) then
		   Pulse <= '0';
		   if Scaled_Clk = '1' then
			   if Button_state(Max) = '0' then
               if Button='1' then
                  Button_State <= Button_State( Max-1 downto 0)&'1';
					else
					   Button_State <= (others =>'0');
					end if;
				else
               if Button='0' then
                  Button_State <= Button_State( Max-1 downto 0)&'0';
					else
					   Button_State <= (others =>'1');
					end if;
				end if;
				-------------------- Debounced output ---------------
				Pulse <= Button_State(Max);
			end if;
	   end if;
	end process;
end Behavioral;

