----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    09:50:59 08/08/2009 
-- Design Name: 
-- Module Name:    Pulse_Button - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity Pulse_Button is
    Generic( Max: Natural := 7);
    Port ( Clk,Scaled_Clk : in  STD_LOGIC;
           Button : 			 in  STD_LOGIC;
           Pulse : 			out  STD_LOGIC);
end Pulse_Button;

architecture Behavioral of Pulse_Button is
   signal Button_State: Std_logic_vector( Max downto 0) := (others =>'0');
begin
   Debounce_process: process( Clk)
	   Variable Toggle_Bit: std_logic := '0'; -- Not in use
	begin
		if Rising_edge( Clk) then
		   Pulse <= '0';
		   if Scaled_Clk = '1' then
			   if Button_state(Max) = '0' then
               if Button='1' then
                  Button_State <= Button_State( Max-1 downto 0)&'1';
					else
					   Button_State <= (others =>'0');
					end if;
				else
               if Button='0' then
                  Button_State <= Button_State( Max-1 downto 0)&'0';
					else
					   Button_State <= (others =>'1');
					end if;
				end if;
				-------------------- Rising edge pulse --------------
				if Button_State( Max downto Max-1)="01" then
				   Pulse <= '1';
				end if;
			end if;
	   end if;
	end process;
end Behavioral;

