----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    23:06:15 08/07/2009 
-- Design Name: 
-- Module Name:    Display_driver - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity Display_driver is
    Port ( Clk,
	        Strobe_in : in    STD_LOGIC;
			  Bcd_Hex:    in    STD_LOGIC;
			  Bin:        in    STD_LOGIC_VECTOR (12 downto 0);
           Ready_out : out   STD_LOGIC;
           Bcd_out :   out   STD_LOGIC_VECTOR (15 downto 0));
end Display_driver;

architecture Behavioral of Display_driver is
   ------------------------------------------------------------------------
	COMPONENT BcdDigit
	PORT(
		Clk : IN std_logic;
		Strobe_in : IN std_logic;
		ReadyIn : IN std_logic;
		ModIn :  IN std_logic;          
		ModOut : OUT std_logic;
		Bcdx :  OUT std_logic_vector(3 downto 0)
		);
	END COMPONENT;
	
   Signal  Mod0,Mod1,Mod2,Mod3: std_logic; 
	Signal  Bcd:                 std_logic_vector(15 downto 0);
	signal  Ready:               std_logic;
   -------------------------------------------------------------------------	
	COMPONENT Binary_reg
	PORT(
		Clk : IN std_logic;
		Bin : IN std_logic_vector(12 downto 0);
		Strobe_in : IN std_logic;          
		Modout : OUT std_logic;
		Ready : OUT std_logic
		);
	END COMPONENT;

BEGIN
	BcdDigit3:  BcdDigit PORT MAP( Clk, Strobe_in, Ready, Mod3,	Open, Bcd(15 downto 12));
	BcdDigit2:  BcdDigit PORT MAP( Clk, Strobe_in, Ready, Mod2,	Mod3, Bcd(11 downto  8));
	BcdDigit1:  BcdDigit PORT MAP( Clk, Strobe_in, Ready, Mod1,	Mod2, Bcd( 7 downto  4));
	BcdDigit0:  BcdDigit PORT MAP( Clk, Strobe_in, Ready, Mod0,	Mod1, Bcd( 3 downto  0));
	
	BinaryReg: Binary_reg PORT MAP( Clk, Bin,	Strobe_in, Mod0, Ready);

   PROCESS( Clk)
	begin
	   if Rising_edge( Clk) then
		   Ready_out <= '0';
		   if Bcd_Hex = '1' then
			   Ready_out <= '1';
				Bcd_out    <=  "000"&Bin;
			elsif Ready='1' then
			   Ready_out <= '1';
				Bcd_out    <=  Bcd;            
         end if;			
		end if;
	end process;

END Behavioral;

