--------------------------------------------------------------------------------
-- Company: 
-- Engineer:
--
-- Create Date:   18:28:07 08/09/2009
-- Design Name:   
-- Module Name:   D:/XilinxPro/Prob11/No10_HiLo_game3/TB_The_Game3.vhd
-- Project Name:  No10_HiLo_game3
-- Target Device:  
-- Tool versions:  
-- Description:   
-- 
-- VHDL Test Bench Created by ISE for module: The_Game3
-- 
-- Dependencies:
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
--
-- Notes: 
-- This testbench has been automatically generated using types std_logic and
-- std_logic_vector for the ports of the unit under test.  Xilinx recommends
-- that these types always be used for the top-level I/O of a design in order
-- to guarantee that the testbench will bind correctly to the post-implementation 
-- simulation model.
--------------------------------------------------------------------------------
LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
USE ieee.std_logic_unsigned.all;
USE ieee.std_logic_arith.all;
USE ieee.numeric_std.ALL;
 
ENTITY TB_The_Game3 IS
END TB_The_Game3;
 
ARCHITECTURE behavior OF TB_The_Game3 IS 
 
    -- Component Declaration for the Unit Under Test (UUT)
 
    COMPONENT The_Game3
    PORT(
         Clk : IN  std_logic;
         Game : IN  std_logic;
         Hi : IN  std_logic;
         Ok : IN  std_logic;
         Lo : IN  std_logic;
         Strobe : OUT  std_logic;
         Ldx : OUT  std_logic_vector(7 downto 0);
         Ready : IN  std_logic;
         Guess : OUT  std_logic_vector(12 downto 0)
        );
    END COMPONENT;  

   --Inputs
   signal Clk : std_logic := '0';
   signal Game : std_logic := '0';
   signal Hi : std_logic := '0';
   signal Ok : std_logic := '0';
   signal Lo : std_logic := '0';
   signal Ready : std_logic := '0';

 	--Outputs
   signal Strobe : std_logic;
   signal Ldx : std_logic_vector(7 downto 0);
   signal Guess : std_logic_vector(12 downto 0);

  -- Clock period definitions
   constant Clk_period : time := 10 ns;
	
	------------- Signals for the Player process ---------------------
	signal Number_to_guess: integer;
	type   states is (Start, Play_the_Game, Wait_a_while, Stop);
	signal state: states := Start;
 
BEGIN
 
	-- Instantiate the Unit Under Test (UUT)
   uut: The_Game3 PORT MAP (
          Clk => Clk,
          Game => Game,
          Hi => Hi,
          Ok => Ok,
          Lo => Lo,
          Strobe => Strobe,
          Ldx => Ldx,
          Ready => Ready,
          Guess => Guess
        );

   -------------------- Clock process definitions ---------------------
   Clk_process :process
   begin
		Clk <= '0';
		wait for Clk_period/2;
		Clk <= '1';
		wait for Clk_period/2;
   end process;
 
   -------------------- This process simulate the Player ------------
	-- Please note! When writing State Machines for simulation c
   The_player: process
   begin		
      wait for Clk_period*2;	
		Number_to_guess <= 1024; 
		loop
		   wait for Clk_period;
		   case state is 
			   when start =>
								if Ready='1' then
									wait for Clk_period*30;
								   game <= '1';
								   wait for Clk_period;
								   game <= '0';
								   state <= Play_the_Game;
								end if;
			   when Play_the_Game =>
								wait for Clk_period * 24;
								if Guess < Number_to_Guess then
								   Lo <= '1';
									wait for Clk_period;
								   Lo <= '0';
								elsif Guess > Number_to_Guess then
								   Hi <= '1';
									wait for Clk_period;
									Hi <= '0';
								elsif Guess = Number_to_Guess then
									Ok <= '1';
									wait for Clk_period;
									Ok <= '0';
									State <= Wait_a_while;
								end if;
			   when Wait_a_while =>
								Number_to_guess <= Number_to_guess + 3333;
								wait for Clk_period;
								if Number_to_guess > 8191 then
								   State <= Stop;
								else
								   State <= Start;
								end if;
			   when Stop =>
								wait;					
			end case;
		end loop;
   end process;

   --------------------- This process simulates the Bin2Bcd converter ------
	Bin2Bcd: process
	begin
      wait for Clk_period*2;	
		Ready <= '1';
		loop
			wait for Clk_period/2;
			if Strobe = '1' then
			   Ready <= '0';
				wait for Clk_period*13;
				Ready <= '1';
			end if;
		end loop;
	end process;
END;
