----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    08:51:05 08/07/2009 
-- Design Name: 
-- Module Name:    The_Game - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity The_Game is
    Generic( N: Natural  := 12);
    Port ( Clk           : in  STD_LOGIC;
           Game,Hi,Ok,Lo : in  STD_LOGIC;
			  Strobe        : out STD_LOGIC; 
			  Ldx           : out STD_LOGIC_VECTOR (7 downto 0); 
           Ready         : in  STD_LOGIC;			  
           Guess 		    : out STD_LOGIC_VECTOR (N downto 0) := (others=>'0'));
end The_Game;

architecture Behavioral of The_Game is
   type States is ( New_game,
						  Wait_for_Bin2Bcd,
						  Wait_for_answer,
						  Number_found);
	signal State: States := New_game;

	shared variable Guess_binary: Std_logic_vector( N downto 0);
	shared variable Guess_bit1:   Std_logic_vector( N downto 0);
	shared variable Guess_bit2:   Std_logic_vector( N downto 0);	
	signal Done: std_logic;
begin
   Ldx  <= "0000000"&Done;  -- Could be used for debug and special funcitions
   
	The_Game_Process: process( Clk)
	begin
		if Rising_edge( Clk) then
		   if Game='1' then
				Strobe <= '1';
				Done   <= '0';
				Guess_binary := (12 =>'1',others=>'0');
				Guess_bit1   := (12 =>'1',others=>'0');
				Guess_bit2   := (11 =>'1',others=>'0');
				State  <= Wait_for_Bin2Bcd;			
			else
				Strobe <= '0';
				case State is
					when New_game => ------------------------------------------
							Strobe <= '1';
							Done   <= '0';
							Guess_binary := (12 =>'1',others=>'0');
							Guess_bit1   := (12 =>'1',others=>'0');
							Guess_bit2   := (11 =>'1',others=>'0');	
							State  <= Wait_for_Bin2Bcd;
					
					when Wait_for_Bin2Bcd => -------------------------------------------
							if Ready = '1' then
								State <= Wait_for_answer;
							end if;
					
					when Wait_for_answer => --------------------------------------------
							if Hi = '1' then  
								Guess_binary := Guess_binary xor (Guess_bit1 or Guess_bit2);
								Guess_bit1   := '0' & Guess_bit1(N downto 1); 
								Guess_bit2   := '0' & Guess_bit2(N downto 1); 
								Strobe <= '1';
								State  <= Wait_for_Bin2Bcd;
							elsif Lo ='1' then 
								Guess_binary := Guess_binary or Guess_bit2;	
								Guess_bit1   := '0' & Guess_bit1(N downto 1); 
								Guess_bit2   := '0' & Guess_bit2(N downto 1); 
								Strobe <= '1';		
								State  <= Wait_for_Bin2Bcd;							
							elsif (Ok = '1') or (Guess_bit2=0) then
								Strobe <= '1';
								Done   <= '1';
								State  <= Number_Found;
							end if;

					when Number_found => -----------------------------------------------
								Null;
				end case;
				Guess <= Guess_Binary;
			end if;
		end if;
	end process;
	
end Behavioral;

