-- Vhdl test bench created from schematic D:\XilinxPro\Prob11\No10_HiLo_game3\The_HiLoGame3.sch - Sun Aug 09 18:40:16 2009
--
-- Notes: 
-- 1) This testbench template has been automatically generated using types
-- std_logic and std_logic_vector for the ports of the unit under test.
-- Xilinx recommends that these types always be used for the top-level
-- I/O of a design in order to guarantee that the testbench will bind
-- correctly to the timing (post-route) simulation model.
-- 2) To use this template as your testbench, change the filename to any
-- name of your choice with the extension .vhd, and use the "Source->Add"
-- menu in Project Navigator to import the testbench. Then
-- edit the user defined section below, adding code to generate the 
-- stimulus for your design.
--
LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
USE ieee.std_logic_unsigned.all;
USE ieee.std_logic_arith.all;
USE ieee.numeric_std.ALL;

LIBRARY UNISIM;
USE UNISIM.Vcomponents.ALL;

ENTITY The_HiLoGame3_The_HiLoGame3_sch_tb IS
END The_HiLoGame3_The_HiLoGame3_sch_tb;

ARCHITECTURE behavioral OF The_HiLoGame3_The_HiLoGame3_sch_tb IS 

   COMPONENT The_HiLoGame3
   PORT( Clk	:	IN	STD_LOGIC; 
          Sw0	:	IN	STD_LOGIC; 
          Game	:	IN	STD_LOGIC; 
          Hi	:	IN	STD_LOGIC; 
          Ok	:	IN	STD_LOGIC; 
          Lo	:	IN	STD_LOGIC; 
          Sw1	:	IN	STD_LOGIC; 
          Ld	:	OUT	STD_LOGIC_VECTOR (7 DOWNTO 0); 
          Bcd	:	OUT	STD_LOGIC_VECTOR (15 DOWNTO 0));
   END COMPONENT;

   SIGNAL Clk	:	STD_LOGIC := '0';
   SIGNAL Sw0	:	STD_LOGIC := '0';
   SIGNAL Game	:	STD_LOGIC := '0';
   SIGNAL Hi	:	STD_LOGIC := '0';
   SIGNAL Ok	:	STD_LOGIC := '0';
   SIGNAL Lo	:	STD_LOGIC := '0';
   SIGNAL Sw1	:	STD_LOGIC := '1';
   SIGNAL Ld	:	STD_LOGIC_VECTOR (7 DOWNTO 0);
   SIGNAL Bcd	:	STD_LOGIC_VECTOR (15 DOWNTO 0);
	
   SIGNAL Guess: integer;
	SIGNAL Ready: Std_Logic :='1';
	
  -- Clock period definitions
   constant Clk_period : time := 10 ns;
	
	------------- Signals for the Player process ---------------------
	signal Number_to_guess: integer;
	type   states is (Start, Play_the_Game, Wait_a_while, Stop);
	signal state: states := Start;
 
BEGIN
   Guess <= conv_integer(Bcd);
	
   UUT: The_HiLoGame3 PORT MAP(
		Clk => Clk, 
		Sw0 => Sw0, 
		Game => Game, 
		Hi => Hi, 
		Ok => Ok, 
		Lo => Lo, 
		Sw1 => Sw1, 
		Ld => Ld, 
		Bcd => Bcd
   );

   -------------------- Clock process definitions ---------------------
   Clk_process :process
   begin
		Clk <= '0';
		wait for Clk_period/2;
		Clk <= '1';
		wait for Clk_period/2;
   end process;
 
   -------------------- This process simulate the Player ------------
	-- Please note! When writing State Machines for simulation c
   The_player: process
   begin		
      wait for Clk_period*2;	
		Number_to_guess <= 1024; 
		loop
		   wait for Clk_period;
		   case state is 
			   when start =>
								if Ready='1' then
									wait for Clk_period*30;
								   game <= '1';
								   wait for Clk_period*10;
								   game <= '0';
								   state <= Play_the_Game;
								end if;
			   when Play_the_Game =>
								wait for Clk_period * 24;
								if Guess < Number_to_Guess then
								   Lo <= '1';
								   wait for Clk_period*10;
								   Lo <= '0';
								elsif Guess > Number_to_Guess then
								   Hi <= '1';
								   wait for Clk_period*10;
									Hi <= '0';
								elsif Guess = Number_to_Guess then
									Ok <= '1';
								   wait for Clk_period*10;
									Ok <= '0';
									State <= Wait_a_while;
								end if;
			   when Wait_a_while =>
								Number_to_guess <= Number_to_guess + 3333;
								wait for Clk_period;
								if Number_to_guess > 8191 then
								   State <= Stop;
								else
								   State <= Start;
								end if;
			   when Stop =>
								wait;					
			end case;
		end loop;
   end process;

--   --------------------- This process simulates the Bin2Bcd converter ------
--	Bin2Bcd: process
--	begin
--      wait for Clk_period*2;	
--		Ready <= '1';
--		loop
--			wait for Clk_period/2;
--			if Strobe = '1' then
--			   Ready <= '0';
--				wait for Clk_period*13;
--				Ready <= '1';
--			end if;
--		end loop;
--	end process;

END;
