----------------------------------------------------------------------------------
-- Alternative verison of the HiLo Game
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity The_Game is
    Generic( N: Natural  := 12);
    Port ( Clk           : in  STD_LOGIC;
           Game,Hi,Ok,Lo : in  STD_LOGIC;
			  Strobe        : out STD_LOGIC; 
			  Ldx           : out STD_LOGIC_VECTOR (7 downto 0); 
           Ready         : in  STD_LOGIC;			  
           Guess 		    : out STD_LOGIC_VECTOR (N downto 0) := (others=>'0'));
end The_Game;

architecture Behavioral of The_Game is
   type States is ( New_game,
						  Wait_for_Bin2Bcd,
						  Wait_for_answer,
						  Number_found);
	signal State: States := New_game;

	shared variable Guess_binary: Std_logic_vector( N downto 0);
	shared variable Guess_bit1:   Std_logic_vector( N downto 0);
	shared variable Guess_bit2:   Std_logic_vector( N downto 0);	
	signal Done: std_logic;
begin
   Ldx  <= "0000000"&Done;  -- Could be used for debug and special funcitions
   
	The_Game_Process: process( Clk)
	begin
		if Rising_edge( Clk) then
		   if Game='1' then
				Strobe <= '1';
				Done   <= '0';
				Guess_binary := (12 =>'1',others=>'0');
				-- Guess_bit1   :=   ......;
				-- Guess_bit2   :=   ......;
				State  <= Wait_for_Bin2Bcd;			
			else
				Strobe <= '0';
				case State is
					when New_game => ------------------------------------------



					
					when Wait_for_Bin2Bcd => -------------------------------------------


					
					when Wait_for_answer => --------------------------------------------




					when others => -----------------------------------------------
								Null;
				end case;
			end if;
			Guess <= Guess_Binary;
		end if;
	end process;
	
end Behavioral;

