----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    16:44:26 08/09/2009 
-- Design Name: 
-- Module Name:    The_Game3 - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity The_Game3 is
    Generic( N: Natural  := 12);
    Port ( Clk           : in  STD_LOGIC;
           Game,Hi,Ok,Lo : in  STD_LOGIC;
			  Strobe        : out STD_LOGIC; 
			  Ldx           : out STD_LOGIC_VECTOR (7 downto 0); 
           Ready         : in  STD_LOGIC;			  
           Guess 		    : out STD_LOGIC_VECTOR (N downto 0) := (others=>'0'));
end The_Game3;

architecture Behavioral of The_Game3 is
   type States is ( New_Game,
	                 Wait_for_Bin2Bcd,
						  Wait_for_answer,
						  Set_Next_bit,
						  Number_found);
	signal State: States := New_Game;

   -- Shared variable used in order to watch the variables in the simulator.
	-- Too bad not possible - try to Signals instead
	shared variable Guess_binary: Std_logic_vector( N downto 0) 
	                              := (12 =>'1',others=>'0');
	shared variable Guess_bit:    Std_logic_vector( N downto 0) 
	                              := (12 =>'1',others=>'0');
	
	signal Done: std_logic;
begin
   Ldx  <= "0000000"&Done;

	The_Game_Process: process( Clk)
	begin
		if Rising_edge( Clk) then
		   if Game='1' then
				Strobe <= '1';
				Done   <= '0';
				Guess_binary := (12 =>'1',others=>'0');
				Guess_bit    := (12 =>'1',others=>'0');
				State  <= Wait_for_Bin2Bcd;			
			else
				Strobe <= '0';
				case State is		
					when New_game => ---------------------------------------------------	
							Strobe <= '1';
							Done   <= '0';
							Guess_binary := (12 =>'1',others=>'0');
							Guess_bit    := (12 =>'1',others=>'0');
							State  <= Wait_for_Bin2Bcd;					
					when Wait_for_Bin2Bcd => -------------------------------------------
							if Ready = '1' then
								State <= Wait_for_answer;
							end if;
								
					when Wait_for_answer => --------------------------------------------
							if Hi = '1' then
								Guess_binary := Guess_binary xor Guess_bit;
								Guess_bit    := '0' & Guess_bit(N downto 1); 
								State  <= Set_Next_bit;	
							elsif Lo ='1' then
								Guess_bit    := '0' & Guess_bit(N downto 1);  
								State  <= Set_Next_bit;							
							elsif (Ok = '1') or (Guess_bit=1) then
								Strobe <= '1';
								Done   <= '1';
								State  <= Number_Found;
							end if;
							
					when Set_Next_bit => -----------------------------------------------
								Guess_binary := Guess_binary or Guess_bit;					
								Strobe <= '1';
								State  <= Wait_for_Bin2Bcd;	
								
					when Number_found => -----------------------------------------------
								Null;
				end case;
			end if;
			Guess <= Guess_Binary;
		end if;
	end process;

end Behavioral;

